var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
// @ts-nocheck
import Icon from 'native-icons';
import React, { useCallback, useEffect, useMemo, useState } from 'react';
import { TouchableOpacity, StyleSheet, View, } from 'react-native';
import * as Progress from 'react-native-progress';
// import type { IconProps } from 'react-native-vector-icons/Icon'
var DEFAULTS = {
    ICON_PAUSE: 'square',
    COLOR: '#fb2c53',
    PLACEHOLDER_COLOR: '#efefef',
};
var PROGRESS_WIDTH = 2;
var SIZES = {
    COMPACT: 12,
    NORMAL: 28,
};
var NativeCircularStatus = function (_a) {
    var progress = _a.progress, _b = _a.iconPause, iconPause = _b === void 0 ? DEFAULTS.ICON_PAUSE : _b, iconPlay = _a.iconPlay, paused = _a.paused, renderContent = _a.renderContent, _c = _a.variant, variant = _c === void 0 ? 'normal' : _c, _d = _a.animated, animated = _d === void 0 ? true : _d, _e = _a.color, color = _e === void 0 ? DEFAULTS.COLOR : _e, _f = _a.placeholderColor, placeholderColor = _f === void 0 ? DEFAULTS.PLACEHOLDER_COLOR : _f, onPause = _a.onPause, onPlay = _a.onPlay, onStatusChanged = _a.onStatusChanged, _g = _a.thinking, thinking = _g === void 0 ? false : _g, disabled = _a.disabled, _h = _a.contentProps, contentProps = _h === void 0 ? {} : _h, _j = _a.iconProps, iconProps = _j === void 0 ? {} : _j, _k = _a.placeholderProps, placeholderProps = _k === void 0 ? {} : _k, _l = _a.progressProps, progressProps = _l === void 0 ? {} : _l, containerProps = __rest(_a, ["progress", "iconPause", "iconPlay", "paused", "renderContent", "variant", "animated", "color", "placeholderColor", "onPause", "onPlay", "onStatusChanged", "thinking", "disabled", "contentProps", "iconProps", "placeholderProps", "progressProps"]);
    var _m = useState(false), isLocalPaused = _m[0], setIsLocalPaused = _m[1];
    useEffect(function () {
        if (paused !== undefined) {
            setIsLocalPaused(paused);
        }
    }, [paused]);
    var handlePress = useCallback(function () {
        if (thinking) {
            return;
        }
        setIsLocalPaused(function (prevState) {
            var updatedState = !prevState;
            if (prevState) {
                onPlay === null || onPlay === void 0 ? void 0 : onPlay();
            }
            else {
                onPause === null || onPause === void 0 ? void 0 : onPause();
            }
            onStatusChanged === null || onStatusChanged === void 0 ? void 0 : onStatusChanged(updatedState);
            return updatedState;
        });
    }, [onPause, onPlay, onStatusChanged, thinking]);
    var size = useMemo(function () {
        switch (variant) {
            case 'compact':
                return SIZES.COMPACT;
            case 'normal':
            default:
                return SIZES.NORMAL;
        }
    }, [variant]);
    var _o = containerProps.style, containerStyle = _o === void 0 ? {} : _o, containerRest = __rest(containerProps, ["style"]);
    var _p = contentProps.style, contentStyle = _p === void 0 ? {} : _p, contentRest = __rest(contentProps, ["style"]);
    var _q = iconProps.style, iconStyle = _q === void 0 ? {} : _q, iconRest = __rest(iconProps, ["style"]);
    var _r = placeholderProps.style, placeholderStyle = _r === void 0 ? {} : _r, placeholderRest = __rest(placeholderProps, ["style"]);
    var innerComponent = useMemo(function () {
        if (renderContent) {
            return renderContent({ progress: progress, paused: isLocalPaused });
        }
        if (isLocalPaused && !iconPlay) {
            return null;
        }
        if (!isLocalPaused && !iconPause) {
            return null;
        }
        return (React.createElement(Icon, __assign({ type: "ionicons", size: 10, color: color, name: isLocalPaused ? iconPlay : iconPause, 
            // style={StyleSheet.flatten([{ paddingLeft: 1 }, iconStyle])}
            style: __assign({ height: 10, width: 10, lineHeight: 10, textAlign: 'center' }, iconStyle) }, iconRest)));
    }, [
        color,
        iconPause,
        iconPlay,
        iconStyle,
        isLocalPaused,
        progress,
        renderContent,
        iconRest,
    ]);
    var isNormal = useMemo(function () { return variant === 'normal'; }, [variant]);
    var isThinkingEnabled = useMemo(function () { return thinking && isNormal; }, [isNormal, thinking]);
    return (React.createElement(TouchableOpacity, __assign({ onPress: handlePress, disabled: disabled, style: StyleSheet.flatten([
            styles.container,
            {
                width: size,
                height: size,
            },
            disabled ? styles.containerDisabled : {},
            containerStyle,
        ]) }, containerRest),
        !thinking && isNormal && (React.createElement(View, __assign({ style: StyleSheet.flatten([
                styles.content,
                styles.absoluteElement,
                contentStyle,
            ]) }, contentRest), innerComponent)),
        React.createElement(Progress.Circle, __assign({ animated: animated, indeterminate: isThinkingEnabled, borderWidth: isThinkingEnabled ? PROGRESS_WIDTH : 0, borderColor: placeholderColor, unfilledColor: isThinkingEnabled ? undefined : placeholderColor, color: color, progress: progress, size: size, thickness: PROGRESS_WIDTH, fill: "#00000000" }, progressProps))));
};
var styles = StyleSheet.create({
    container: {
        position: 'relative',
    },
    containerDisabled: {
        opacity: 0.5,
    },
    content: {
        justifyContent: 'center',
        alignItems: 'center',
    },
    absoluteElement: {
        position: 'absolute',
        width: '100%',
        height: '100%',
    },
});
export default NativeCircularStatus;
